﻿$threshold = 20
$directory = "E:\test"
$days = 30

while ($true) {
    # 检查磁盘空间
    $drive = Get-PSDrive E

    # 将字节转换为GB
    $usedGB = [math]::round($drive.Used / 1GB, 2)
    $freeGB = [math]::round($drive.Free / 1GB, 2)
    $totalSizeGB = $usedGB + $freeGB

    # 输出调试信息
    Write-Host "Used: $usedGB GB, Free: $freeGB GB, Total: $totalSizeGB GB"

    # 检查驱动器大小是否有效
    if ($totalSizeGB -gt 0) {
        # 计算目标剩余空间
        $targetFreeSpaceGB = [math]::round(($threshold / 100) * $totalSizeGB, 2)

        # 检查当前剩余空间是否低于目标
        if ($freeGB -lt $targetFreeSpaceGB) {
            # 进行清理
            while ($freeGB -lt $targetFreeSpaceGB) {
                # 获取最老的文件
                $filesToDelete = Get-ChildItem $directory -Recurse -File | Sort-Object LastWriteTime | Select-Object -First 1

                if ($filesToDelete) {
                    # 删除文件
                    Remove-Item $filesToDelete.FullName -Force

                    # 更新磁盘信息
                    $drive = Get-PSDrive E
                    $usedGB = [math]::round($drive.Used / 1GB, 2)
                    $freeGB = [math]::round($drive.Free / 1GB, 2)

                    # 输出当前状态
                    Write-Host "Deleted: $($filesToDelete.FullName), Used: $usedGB GB, Free: $freeGB GB"

                    # 尝试删除文件所在的空文件夹
                    $parentDir = $filesToDelete.Directory.FullName
                    if (-not (Get-ChildItem $parentDir)) {
                        Remove-Item $parentDir -Force
                        Write-Host "Deleted empty folder: $parentDir"
                    }

                    # 检查是否达到目标剩余空间
                    if ($freeGB -ge $targetFreeSpaceGB) {
                        Write-Host "已达到目标剩余空间: $targetFreeSpaceGB GB"
                        break
                    }
                } else {
                    Write-Host "没有更多文件可删除。"
                    break # 如果没有可删除的文件，退出循环
                }
            }
        } else {
            Write-Host "当前剩余空间已足够。"
        }
    } else {
        Write-Host "驱动器大小无效，无法进行磁盘空间检查。"
    }

    # 每分钟检查一次
    Start-Sleep -Seconds 60
}
